       TITLE 'REQUEST HANDLER PROCESS ROOT ACTIVITY PROGRAM'
      *****************************************************************
      *                                                               *
      * MODULE NAME = IJMRPROC                                        *
      *                                                               *
      * DESCRIPTIVE NAME = REQUEST HANDLER PROCESS ROOT ACTIVITY      *
      *                                                               *
      * STATUS = SUPPORTED BY CICS TRANSACTION SERVER 1.3 OR LATER    *
      *                                                               *
      *---------------------------------------------------------------*
      *                                                               *
      * CHANGE ACTIVITY :                                             *
      *                                                               *
      * 210202  IJM   : Created                                       *
      *                                                               *
      *---------------------------------------------------------------*
      *****************************************************************
      *             PROGRAM DESCRIPTION                               *
      *****************************************************************
      *                                                               *
      * ...                                                           *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID.  IJMRPROC.
      *
       AUTHOR.      IBM.
      *
       DATE-COMPILED.
      *
      *REMARKS.
      *****************************************************************
      *                                                               *
      *                                                               *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
      *
       CONFIGURATION SECTION.
      *
       SPECIAL-NAMES.
      *
       DATA DIVISION.

       WORKING-STORAGE SECTION.

       01  WS-START                        PIC X(44)
           VALUE '*** SORDISP  WORKING STORAGE STARTS HERE ***'.

       COPY IJMRCON.

      * WORKING VARIABLES
       01  EVENT-TYPE                      PIC 9(8)  COMP.
       01  REQUEST-EVENT                   PIC X(16).
           88 DO-PHASE1                    VALUE 'DFHINITIAL'.
           88 DO-PHASE2                    VALUE 'PHASE2'.
           88 DO-PHASE3                    VALUE 'PHASE3'.
       01  ROOTID-VALUE                    PIC X(52).
      *
       LINKAGE SECTION.
      *
       PROCEDURE DIVISION.

      ******************************************************************
      *BEGIN-PROCESS                                                   *
      ******************************************************************
       BEGIN-PROCESS.

      * FIND OUT THE EVENT TO BE PROCESSED.

           EXEC CICS RETRIEVE REATTACH
                     EVENT(REQUEST-EVENT)
                     EVENTTYPE(EVENT-TYPE)
           END-EXEC.

      * PROCESS THE EVENT

           EVALUATE TRUE
             WHEN DO-PHASE1
               PERFORM PHASE1-ACTIONS
             WHEN DO-PHASE2
               PERFORM PHASE2-ACTIONS
             WHEN DO-PHASE3
               PERFORM PHASE3-ACTIONS
           END-EVALUATE.

           EXEC CICS RETURN
           END-EXEC.

       PHASE1-ACTIONS.
      *      DEFINE THE EVENT FOR THE NEXT PHASE
               EXEC CICS DEFINE INPUT EVENT(PHASE2)
               END-EXEC.

      *      CAPTURE THE ACTIVITY ID
               EXEC CICS ASSIGN ACTIVITYID(ROOTID-VALUE)
               END-EXEC.

      *      RETURN THE ACTIVITY ID IN A CONTAINER
               EXEC CICS PUT CONTAINER(ROOTID-CONTAINER)
                         FROM(ROOTID-VALUE)
               END-EXEC.
       PHASE2-ACTIONS.
      *      DEFINE THE EVENT FOR THE NEXT PHASE
               EXEC CICS DEFINE INPUT EVENT(PHASE3)
               END-EXEC.
      *      INVOKE THE APPLICATION REQUEST HANDLER
               EXEC CICS LINK PROGRAM(APPHANDLER)
               END-EXEC.
      *      DELETE THE CURRENT EVENT
               EXEC CICS DELETE EVENT(PHASE2)
               END-EXEC.
       PHASE3-ACTIONS.
      *      DELETE THE CURRENT EVENT
               EXEC CICS DELETE EVENT(PHASE3)
               END-EXEC.
      ******************************************************************
      *DUMMY-GOBACK                                                    *
      *BECAUSE SOME COMPILERS NEED IT                                  *
      ******************************************************************
       DUMMY-GOBACK.
            GOBACK.
      *
